import mailchimp_marketing as MailchimpMarketing
from django.conf import settings
from mailchimp_marketing.api_client import ApiClientError

class MailchimpService:
    def __init__(self):
        self.client = MailchimpMarketing.Client()
        self.client.set_config({
            "api_key": settings.MAILCHIMP_API_KEY,
            "server": settings.MAILCHIMP_REGION
        })

    def subscribe_email(self, email, first_name=None, last_name=None):
        try:
            member_info = {
                "email_address": email,
                "status": "subscribed",
                "merge_fields": {}
            }
            
            if first_name:
                member_info["merge_fields"]["FNAME"] = first_name
            if last_name:
                member_info["merge_fields"]["LNAME"] = last_name

            response = self.client.lists.add_list_member(
                settings.MAILCHIMP_LIST_ID,
                member_info
            )
            return True, response
        except ApiClientError as error:
            return False, str(error.text)

